#!/usr/bin/python3

import pandas as pd
import numpy as np
from twilio.rest import Client
import datetime as dt #get & manipulate dates & time
from dateutil.relativedelta import relativedelta
from sys import exit

# Find these values at https://twilio.com/user/account
account_sid = 'YOUR ACCOUNT SID FROM STEP 1'
auth_token = 'YOUR AUTHENTICATION TOKEN FROM STEP 1'

to_phone = 'PHONE NUMBER TO GET REMINDERS' #twilio registered phone number 
from_phone = 'PHONE NUMBER SENDIG REMIDERS' #twilio trial phone number

#change this to remind you X days in advance
remind_buffer = 0 #I like to know the day of

#create the twilio client
client = Client(account_sid, auth_token)

#current date + buffer
today = pd.to_datetime(dt.date.today() + relativedelta(days=+remind_buffer)) #could also be: weeks, months, etc.

#pull in the birthday list 
birthdays = pd.read_csv("/home/pi/share/Birthday_List.csv", parse_dates=['Birthday']) #/home/pi/share/

birthdays['Today'] = today

#get the current month
birthdays['date_Month'] = today
birthdays['date_Month'] = birthdays['date_Month'].dt.month

#get the current day
birthdays['date_Day'] = today
birthdays['date_Day'] = birthdays['date_Day'].dt.day

#get the current month
birthdays['bd_Month'] = birthdays['Birthday'].dt.month
birthdays['bd_Day'] = birthdays['Birthday'].dt.day

#compute the age
birthdays['age'] = (birthdays['Today'] - birthdays['Birthday']) / np.timedelta64(1,'Y')
birthdays['age'] = birthdays['age'].round(0).astype('int64')

#isloate the birthdays that have the same day and month, ignore the year
celebrate = birthdays.loc[(birthdays['bd_Month'] == birthdays['date_Month']) & (birthdays['bd_Day'] == birthdays['date_Day'])]

#how many items are on the list
count_day = len(celebrate.index)

#grammer police
if count_day > 1:
    s = 's'
else:
    s = ''
	
if remind_buffer != 0:
	remind_words = ' in ' + str(remind_buffer) +' day(s)!'
else:
	remind_words = ' today! '
	
#if no items, then just end, nothing to do
if count_day == 0:
    exit()
elif count_day != 0: #item about to expire, go ahead and draft the text message
    week_body = str(count_day) + ' birthday' + s + ' - '
    
    for index, row in celebrate.iterrows():
     week_body = week_body + ' ' + row['Name'] + " is " + str(row['age']) + remind_words

#create the message to phone    
client.api.account.messages.create(
    to= to_phone,
    from_= from_phone,
    body=week_body)